## tworld 2.3.0

=== CMakeLists.txt ===
# CMake build system for Tile World 2
#
# Copyright (C) 2020 by Michael Hansen, under the GNU General Public
# License. No warranty. See COPYING for details.

cmake_minimum_required(VERSION 3.20)
project(tworld)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED TRUE)

set(OSHW "qt" CACHE STRING "OS/HW Flavor to build (sdl or qt)")
set_property(CACHE OSHW PROPERTY STRINGS qt sdl)

if(OSHW STREQUAL "qt")
    set(TWORLD_EXE "tworld2")
elseif(OSHW STREQUAL "sdl")
    set(TWORLD_EXE "tworld")
else()
    message(FATAL_ERROR "${OSHW} is not a valid OSHW setting")
endif()

if(OSHW STREQUAL "sdl")
    find_package(SDL REQUIRED)
endif()

if(OSHW STREQUAL "qt")
    set(CMAKE_AUTOUIC TRUE)
    set(CMAKE_AUTOMOC TRUE)
    set(CMAKE_AUTORCC TRUE)
    # We use SDL2 for the Qt build for audio.
    find_package(SDL2 REQUIRED)
    find_package(Qt6 COMPONENTS Core Gui Widgets Xml)
    if(NOT Qt6_FOUND)
        find_package(Qt5 REQUIRED COMPONENTS Core Gui Widgets Xml)
        if(Qt5_FOUND AND NOT TARGET Qt::Core)
            # The version-generic targets were only added in Qt 5.15
            add_library(Qt::Core INTERFACE IMPORTED)
            set_target_properties(Qt::Core PROPERTIES INTERFACE_LINK_LIBRARIES "Qt5::Core")
            add_library(Qt::Gui INTERFACE IMPORTED)
            set_target_properties(Qt::Gui PROPERTIES INTERFACE_LINK_LIBRARIES "Qt5::Gui")
            add_library(Qt::Widgets INTERFACE IMPORTED)
            set_target_properties(Qt::Widgets PROPERTIES INTERFACE_LINK_LIBRARIES "Qt5::Widgets")
            add_library(Qt::Xml INTERFACE IMPORTED)
            set_target_properties(Qt::Xml PROPERTIES INTERFACE_LINK_LIBRARIES "Qt5::Xml")
        endif()
    endif()
    add_definitions(-DTWPLUSPLUS)
endif()

file(GLOB TW_SETS "${CMAKE_CURRENT_SOURCE_DIR}/sets/*.dac")
file(GLOB TW_DATA "${CMAKE_CURRENT_SOURCE_DIR}/data/*.dat"
                  "${CMAKE_CURRENT_SOURCE_DIR}/data/*.ccx")
file(GLOB TW_RES  "${CMAKE_CURRENT_SOURCE_DIR}/res/rc"
                  "${CMAKE_CURRENT_SOURCE_DIR}/res/*.bmp"
                  "${CMAKE_CURRENT_SOURCE_DIR}/res/*.txt"
                  "${CMAKE_CURRENT_SOURCE_DIR}/res/*.wav")
file(GLOB TW_MAN6 "${CMAKE_CURRENT_SOURCE_DIR}/docs/*.6")
file(GLOB TW_CCLP_DOCS "${CMAKE_CURRENT_SOURCE_DIR}/docs/CCLP*")

if(WIN32)
    file(GLOB TW_DOCS "${CMAKE_CURRENT_SOURCE_DIR}/docs/*.html")

    install(FILES ${TW_SETS} DESTINATION "${CMAKE_INSTALL_PREFIX}/sets")
    install(FILES ${TW_DATA} DESTINATION "${CMAKE_INSTALL_PREFIX}/data")
    install(FILES ${TW_RES}  DESTINATION "${CMAKE_INSTALL_PREFIX}/res")
    install(FILES ${TW_DOCS} DESTINATION "${CMAKE_INSTALL_PREFIX}/docs")
    install(DIRECTORY ${TW_CCLP_DOCS} DESTINATION "${CMAKE_INSTALL_PREFIX}/docs")
else()
    set(SHARE_DIR "${CMAKE_INSTALL_PREFIX}/share/tworld" CACHE STRING
        "Directory for shared files")
    add_definitions(-Dstricmp=strcasecmp)

    if(NOT CMAKE_BUILD_TYPE STREQUAL "Debug")
        add_definitions(-DROOTDIR="${SHARE_DIR}")
    else()
        add_definitions(-DSAVEDIR="./save")
    endif()

    install(FILES ${TW_SETS} DESTINATION "${SHARE_DIR}/sets")
    install(FILES ${TW_DATA} DESTINATION "${SHARE_DIR}/data")
    install(FILES ${TW_RES}  DESTINATION "${SHARE_DIR}/res")
    install(FILES ${TW_MAN6} DESTINATION "${CMAKE_INSTALL_PREFIX}/man/man6")
    install(DIRECTORY ${TW_CCLP_DOCS} DESTINATION "${SHARE_DIR}/docs")
endif()

add_subdirectory(oshw-${OSHW})

add_executable(${TWORLD_EXE} WIN32 MACOSX_BUNDLE tworld.c)
target_sources(${TWORLD_EXE} PRIVATE
    cmdline.h
    cmdline.c
    comptime.h
    defs.h
    encoding.h
    encoding.c
    err.h
    err.c
    fileio.h
    fileio.c
    gen.h
    help.h
    help.c
    logic.h
    lxlogic.c
    messages.h
    messages.cpp
    mslogic.c
    oshw.h
    play.h
    play.c
    random.h
    random.c
    res.h
    res.c
    score.h
    score.cpp
    series.h
    series.c
    settings.h
    settings.cpp
    solution.h
    solution.c
    state.h
    unslist.h
    unslist.c
    ver.h
)

if(WIN32)
    target_sources(${TWORLD_EXE} PRIVATE ${TWORLD_EXE}.rc)
endif()

if(OSHW STREQUAL "qt")
    target_sources(${TWORLD_EXE} PRIVATE tworld2.qrc)
endif()


target_link_libraries(${TWORLD_EXE} PRIVATE oshw-${OSHW})
if(WIN32)
    target_link_libraries(${TWORLD_EXE} PRIVATE $<$<CONFIG:Debug>:-mconsole>)
endif()

if(OSHW STREQUAL "qt")
    target_link_libraries(${TWORLD_EXE} PRIVATE SDL2::SDL2)
endif()

# Generate the current compile time
if(WIN32)
    # TODO: It would be nice to use the format below on Win32 as well...
    file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/comptime.bat"
         "echo #define COMPILE_TIME \"%DATE% %TIME%\" > comptime.h")
    add_custom_command(
        OUTPUT comptime.h
        COMMAND comptime.bat
    )
else()
    file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/comptime.sh"
         "echo \"#define COMPILE_TIME \\\"`date '+%Y %b %e %T %Z'`\\\"\" > comptime.h")
    add_custom_command(
        OUTPUT comptime.h
        COMMAND /bin/sh comptime.sh
    )
endif()

set_property(SOURCE comptime.h PROPERTY SKIP_AUTOGEN ON)
target_include_directories(${TWORLD_EXE} PRIVATE "${CMAKE_CURRENT_BINARY_DIR}")

if(WIN32 OR APPLE)
    install(TARGETS ${TWORLD_EXE}
            RUNTIME DESTINATION .
            BUNDLE DESTINATION .
    )
else()
    install(TARGETS ${TWORLD_EXE} RUNTIME DESTINATION bin)
endif()

add_executable(mklynxcc EXCLUDE_FROM_ALL mklynxcc.c)

=== oshw-qt/CMakeLists.txt ===
add_library(oshw-qt STATIC "")
target_sources(oshw-qt PRIVATE
    ../generic/generic.h
    ../generic/_in.cpp
    ../generic/tile.c
    ../generic/timer.c
    ../oshw-sdl/sdlsfx.h
    ../oshw-sdl/sdlsfx.c
    oshwbind.h
    oshwbind.cpp
    CCMetaData.h
    CCMetaData.cpp
    TWApp.h
    TWApp.cpp
    TWDisplayWidget.h
    TWDisplayWidget.cpp
    TWMainWnd.h
    TWMainWnd.cpp
    TWMainWnd.ui
    TWProgressBar.h
    TWProgressBar.cpp
    TWTextCoder.cpp
    TWTextCoder.h
)

target_include_directories(oshw-qt PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_SOURCE_DIR}
    ${CMAKE_SOURCE_DIR}/generic
    ${SDL2_INCLUDE_DIR}
)

target_link_libraries(oshw-qt PUBLIC
    ${SDL2_LIBRARY}
    Qt::Core
    Qt::Gui
    Qt::Widgets
    Qt::Xml
)

=== oshw-sdl/CMakeLists.txt ===
add_library(oshw-sdl STATIC "")
target_sources(oshw-sdl PRIVATE
    ../generic/generic.h
    ../generic/in.c
    ../generic/tile.c
    ../generic/timer.c
    oshwbind.h
    oshwbind.c
    sdlerr.c
    sdlgen.h
    sdlin.c
    sdloshw.c
    sdlout.c
    sdlsfx.h
    sdlsfx.c
    sdltext.c
)

target_include_directories(oshw-sdl PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_SOURCE_DIR}
    ${CMAKE_SOURCE_DIR}/generic
    ${SDL_INCLUDE_DIR}
)

target_link_libraries(oshw-sdl PUBLIC ${SDL_LIBRARY})

## tworld 1.3.2

=== debian/changelog ===
tworld (1.3.2-4) unstable; urgency=medium

  * Update Vcs-* fields.
  * Bump Standards-Version to 4.6.2.
  * Use debhelper-compat 13.
  * Use https URL in debian/watch, and use version=4.
  * Remove menu file.
  * Use DEB_BUILD_MAINT_OPTIONS hardening=+all.
  * Change debian/copyright to DEP5.

 -- Rhonda D'Vine <rhonda@debian.org>  Tue, 17 Jan 2023 12:46:06 +0100

tworld (1.3.2-3) unstable; urgency=medium

  * Remove doc symlink to -data package from tworld to make it binNMUable
    (closes: #857974)
  * Install docs into tworld package instead of tworld-data.
  * Bump Standards-Version to 3.9.8.

 -- Rhonda D'Vine <rhonda@debian.org>  Wed, 22 Mar 2017 09:54:26 +0100

tworld (1.3.2-2) unstable; urgency=medium

  * Fix reproducible issue, thanks to Chris Lamb for finding the spot to
    tweak. Closes: #792980 is about a different issue, but that one is fixed
    and the one report about reproducible build open so closing it here.
  * Get rid of ancient postinst script from oldstable times.
  * Apply patch provided by upstream to support DESTDIR and use
    dh_auto_install again.

 -- Rhonda D'Vine <rhonda@debian.org>  Tue, 05 Jan 2016 14:23:32 +0100

tworld (1.3.2-1) unstable; urgency=medium

  * New Upstream release (closes: #807623)
  * Update 01_fix-manpage and refresh 02_integer-types patches.
  * Change debian/rules to dh style.
  * Change source format to 3.0 (quilt).
  * Bump Standards-Version to 3.9.6.
  * Add patch 03_fix-Makefile.in to make clean work (repeatedly).
  * Update VCS-* links.

 -- Rhonda D'Vine <rhonda@debian.org>  Fri, 01 Jan 2016 03:11:43 +0100

tworld (1.3.0-6) unstable; urgency=low

  [ Peter Pentchev ]
  * Add patch from Drake Wilson to fix solution files for 64 bit architectures
    (closes: #427360; LP: #307897)
  * Explicit call set -e in maintainer scripts.
  * Enhance short description of -data package.

  [ Gerfried Fuchs ]
  * Bump Standards-Version to 3.9.2.
  * Switch packaging licensing to WTFPLv2.
  * Supress error message in postinst if rmdir fails. Also, use lt-nl rather
    than le-nl.
  * Add Changelog as upstream changelog.
  * Add some typo fixes into patch fix-manpage.

 -- Gerfried Fuchs <rhonda@debian.org>  Tue, 24 May 2011 22:53:12 +0200

tworld (1.3.0-5) unstable; urgency=low

  * Switch doc dir from tworld to symlink as dpkg isn't able to do so.

 -- Gerfried Fuchs <rhonda@debian.at>  Fri, 12 Sep 2008 15:13:35 +0200

tworld (1.3.0-4) unstable; urgency=low

  * Removed debian/docs cruft.
  * Switched Maintainer to Games Team.
  * Added copyright informations for c4 to debian/copyright.
  * Switched packaging licensing to BSD style.
  * Added Vcs-* informations to debian/control.
  * Split the architecture independent data files into its own tworld-data
    package.
  * Use filter instead of findstring for DEB_BUILD_OPTIONS parsing as
    suggested by policy.
  * Strip unneeded sections from binary.

 -- Gerfried Fuchs <rhonda@debian.at>  Fri, 12 Sep 2008 13:40:26 +0200

tworld (1.3.0-3) unstable; urgency=low

  * Updated to Standards-Version 3.8.0:
    - Added Homepage source control field.
    - Added README.source because of quilt usage.
  * Add patch for fixing the manual pages, add quilt Build-Depends for that.
  * Updated copyright informations a bit.
  * Moved c4 into the debian directory, no changes outside of debian/ anymore.
  * Add desktop file (LP: #220311)

 -- Gerfried Fuchs <rhonda@debian.at>  Tue, 10 Jun 2008 12:53:47 +0200

tworld (1.3.0-2) unstable; urgency=low

  * Remove -s from LDFLAGS, makes DEB_BUILD_OPTIONS=nostrip work
    (closes: #438228)
  * Remove perl from Build-Depends since it's Build-Essential: yes.
  * Test for Makefile instead of ignoring make clean errors.
  * Switched to menu section Games/Puzzles due to removed Arcade section from
    new menu policy.
  * Added menu icon debian/tworld.xpm extracted from res/tiles.bmp.

 -- Gerfried Fuchs <rhonda@debian.at>  Mon, 20 Aug 2007 14:50:49 +0200

tworld (1.3.0-1) unstable; urgency=low

  * Initial release (closes: #373416)

 -- Gerfried Fuchs <alfie@debian.org>  Tue, 13 Jun 2006 06:27:02 -0500

=== debian/control ===
Source: tworld
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Rhonda D'Vine <rhonda@debian.org>
Build-Depends: debhelper-compat (= 13), libsdl1.2-dev
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/pkg-games/tworld.git
Vcs-Browser: https://salsa.debian.org/pkg-games/tworld
Homepage: http://www.muppetlabs.com/~breadbox/software/tworld/

Package: tworld-data
Architecture: all
Replaces: tworld (<< 1.3.0-4)
Depends: ${misc:Depends}
Description: Chip's Challenge Game Engine Emulation - level data files
 Tile World is an emulation of the game "Chip's Challenge".  "Chip's
 Challenge" was originally written for the Atari Lynx by Chuck Sommerville,
 and was later ported to MS Windows by Microsoft (among other ports).
 .
 This package contains the architecture independent data files.

Package: tworld
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, tworld-data (= ${source:Version})
Description: Chip's Challenge Game Engine Emulation
 Tile World is an emulation of the game "Chip's Challenge".  "Chip's
 Challenge" was originally written for the Atari Lynx by Chuck Sommerville,
 and was later ported to MS Windows by Microsoft (among other ports).
 .
 Please note: Tile World is an emulation of the game engine(s) only.  It does
 not come with the chips.dat file that contains the original level set.  This
 file is copyrighted and cannot be freely distributed.  The chips.dat file
 was originally part of the MS version of "Chip's Challenge".  If you have a
 copy of this version of the game, you can use that file to play the game in
 Tile World.  If you do not have a copy of this file, however, you can still
 play Tile World with the many freely available level sets created by fans of
 the original game, including CCLP2.  Because the version that Microsoft
 released introduced a number of changes to the rules of the game, Tile World
 is capable of emulating either the MS version or the original Atari Lynx
 version of the game.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

BUILD_DATE := $(shell dpkg-parsechangelog | sed -n -e 's/^Date: //p')

%:
	dh $@

override_dh_clean:
	rm -f Makefile oshw-sdl/Makefile oshw
	dh_clean

override_dh_auto_configure:
	dh_auto_configure -- --bindir=/usr/games --with-sharedir=/usr/share/games/tworld

override_dh_auto_build:
	echo \#define COMPILE_TIME \"$(BUILD_DATE)\" > comptime.h
	dh_auto_build

override_dh_auto_install:
	mkdir -p debian/tworld-data/usr/share/man/man6
	pod2man -s 6 -r 'Tile World' -c '' debian/c4 \
		debian/tworld-data/usr/share/man/man6/c4.6
	dh_auto_install

=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

https://www.muppetlabs.com/~breadbox/pub/software/tworld/  tworld-([0-9.]+)\.tar\.gz  debian  uupdate
# URL                                                      pattern                    version  script

## tworld 2.3.0

=== debian/changelog ===
tworld (2.3.0-1) unstable; urgency=medium

  * d/watch: switch to follow github upstream.
  * New upstream version 2.3.0
  * d/control: change homepage.
  * d/control: switch to SV 4.7.0.
  * d/control: add R3: no.
  * d/control: update BD with qt6 and sdl2.
  * d/patches: refresh.
  * d/u/metadata: added.
  * d/copyright: update.
  * d/rules: simplified since upstream uses cmake.
  * d/*.{install,docs,desktop}: binary is tworld2.
  * d/README.source: removed, not very useful.
  * d/salsa-ci.yml: added to use Salsa CI.

 -- Patrice Duroux <patrice.duroux@gmail.com>  Sun, 16 Feb 2025 19:46:00 +0100

tworld (1.3.2-5) unstable; urgency=medium

  * Team Upload
  * Apply Multi-Arch: hint

  [ Rhonda D'Vine ]
  * Fix Vcs-* fields.

  [ Helmut Grohne ]
  * Fix FTCBFS: Let dpkg's buildtools.mk export CC for configure. (Closes: #946136)

 -- Alexandre Detiste <tchet@debian.org>  Sun, 10 Nov 2024 19:38:04 +0100

=== debian/control ===
--- 
+++ 
@@ -3,14 +3,16 @@
 Priority: optional
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders: Rhonda D'Vine <rhonda@debian.org>
-Build-Depends: debhelper-compat (= 13), libsdl1.2-dev
-Standards-Version: 4.6.2
-Vcs-Git: https://salsa.debian.org/pkg-games/tworld.git
-Vcs-Browser: https://salsa.debian.org/pkg-games/tworld
-Homepage: http://www.muppetlabs.com/~breadbox/software/tworld/
+Build-Depends: debhelper-compat (= 13), cmake, libsdl2-dev, qt6-base-dev
+Standards-Version: 4.7.0
+Rules-Requires-Root: no
+Vcs-Git: https://salsa.debian.org/games-team/tworld.git
+Vcs-Browser: https://salsa.debian.org/games-team/tworld
+Homepage: https://tw2.bitbusters.club
 
 Package: tworld-data
 Architecture: all
+Multi-Arch: foreign
 Replaces: tworld (<< 1.3.0-4)
 Depends: ${misc:Depends}
 Description: Chip's Challenge Game Engine Emulation - level data files

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
BUILD_DATE := $(shell dpkg-parsechangelog | sed -n -e 's/^Date: //p')

%:
	dh $@

override_dh_auto_build:
	echo \#define COMPILE_TIME \"$(BUILD_DATE)\" > comptime.h
	dh_auto_build -- SKIP_AUTOGEN=ON

execute_after_dh_auto_install:
	pod2man -s 6 -r 'Tile World' -c '' debian/c4 \
		debian/tmp/usr/share/man/man6/c4.6

=== debian/watch ===
version=4
https://github.com/SicklySilverMoon/tworld/tags .+/@ANY_VERSION@@ARCHIVE_EXT@
